package ui.view;

import java.awt.EventQueue;

import javax.swing.UIManager;
import javax.swing.UnsupportedLookAndFeelException;

import ui.controller.*;
import ui.model.*;

public class Main {

	public static void main(String[] args) {

		// *Design
		try {
			UIManager.setLookAndFeel(UIManager.getSystemLookAndFeelClassName());
		} catch (ClassNotFoundException | InstantiationException | IllegalAccessException
				| UnsupportedLookAndFeelException e1) {
			// TODO Auto-generated catch block
			e1.printStackTrace();
		}

		EventQueue.invokeLater(new Runnable() {
			public void run() {
				try {
					IdCounter 	ID = new IdCounter();
					Model 		M = new Model();
					GUI 		V = new GUI(M);
					Control 	C = new Control(M, V, ID);

					V.refreshCategories();
					V.getFrmCyberPhysical().setVisible(true);

				} catch (Exception e) {
					e.printStackTrace();
				}
			}
		});
	}

}
